# 2020-065 - **Interior Design using Augmented Reality**

Group Details
-------------
|     | Developer | IT No:   |
| :------- | :---- | :--- |
| Project Leader | E.M.P.S Ekanayaka | IT17131698    |
|  | W.M.D.R Fonseka  | IT17160926 |
|    | R.N Ranaweerasinghe    | IT17075190    |
|     | Abeykoon A.M.A.C.B   | IT17025904    |

**Supervisor**    | **Co-Supervisor**
:--------: | :---:
Mr.Aruna Ishara Gamage | Mr.Thusithanjana  Thilakarathna
    

----------

**Project Description**
-------------

**ARInterior** is an indoor mobile application which helps to overcome  the gap of the design interpretation in the process of traditional Interior Designing. Specifically, it evaluate the best way to communicate the concept of Interior Designing to the client in an immersive virtual blueprint.

> **Note:**

> - Create a virtual measuring tool by utilizing the AR and computer vision algorithms.
> - Sort out the best wall paint color and estimate the number of coats by applying Machine Learning (ML) algorithms.
> - Sort out the best matched furniture by utilizing decision tree algorithm.
> Distinguish the best furniture to position according to Interior design principles by using marker less Simultaneous Localization and Mapping (SLAM) mobile technologies


----------

**Research Question**
-----------------

 * Most common issue is that the client does not have a very clear idea
 of the final interior output even though the professional explain the
 plan of interior arrangement.The client does not possess the imagination to visualize final output until the designer complete the interior arrangement.
 When the decorations is done, it is **not what client expected** and it leads to a dissatisfaction.


**Research Objectives**
-------------------

Main Objective
--------------

 - Providing virtual solutions for the complications encounter during
   the process of Interior Designing.

Specific Objectives
-------------------

 -  Object Detection and Measurement
 - Wall Paint Visualization and Suggest the Number of Paint Coats
 -  Specify suitable furniture and decorations
 -  Position Recommendations

**Individual Components**
---------------------

Object Detection and Measurement
--------------------------------

A method for measuring a particular distance within a room-scale, with the help of a mobile Augmented Reality system is presented. AR Interior uses a technology to measure an object or a plane using a smart mobile phone. 

This measuring techniques using AR can be more effective with the
combination of computer vision algorithms. Making possible to identify objects within a room separately giving an image of an object and
getting predictions of what the object is by putting boundary boxes. Training image domains to identify windows, doors or switches to calculate and visualize the area of these objects real-time. 

Wall Paint Visualization and Suggest the Number of Paint Coats
---------------------------------------
In the research component,  visualizing the selected color on the wall and implementing a method to suggest how many numbers of paint coats are needed to apply on the wall is present. For each color, every possible event where existing color and the required color to paint is classified.Thereafter, it creates a separate data set which full fill every possibility for the user to get the number of paint coats which is in high accuracy. In order to identify the current wall color from an image, a machine learning algorithm is used.

Specify Suitable Furniture and Decorations
------------------------------------------
User select a collection of furniture for the room, therefor, user fill out the smart questionnaire from the system. A few questions will be asked to understand the user's personality. Thereafter,  the system analyzes the information .It gets information about the room’s purpose and retrieve information from a database including room measurements and color of the walls. Finally,  analyze the data and system suggests a list of best furniture. 

Position Recommendations
------------------------
As one of main objective of the study is accurate and stable placement of the virtual furniture,  application activates device camera to instruct user to point at the space where furniture needed to be visualized. Next, user can place furniture in real-time on the surface detected . The system also recommends the user which furniture to place first. Furthermore, system indicates relationships between furniture pieces and recommend distances between each furniture according to interior design rules and practices. This is accomplished by following a rule-based algorithm which describes relationships between furniture pieces.

**System Module and The Architecture**
----------------------------------

Module    | Path to the Code file
-------- | ---
Object Detection and Measurement | Branch "Dulika" --> Directory "IT17160926" 
Wall Paint Visualization and Suggest the Number of Paint Coats   | Branch "Nihara"  --> Directory "IT17075190" 
Specify Suitable Furniture and Decorations   | Branch "Poornima"  --> Directory "IT17131698"
Position Recommendations  | Branch "Anjana" --> Directory "IT17025904 "


Research Dataset
----------------------------------
Component   | Data Set
-------- | ---
Wall Paint Visualization and Suggest the Number of Paint Coats | https://drive.google.com/drive/folders/1bxL3Tia7pqAq3aSer589x7VAo77BVsyc?usp=sharing
Furniture Suggession | https://drive.google.com/file/d/1wp1W2ZQzjo9OrN8RGOCSHBZu1sVMz5sN/view?usp=sharing

**Installation Procedure**
----------------------------------

Object Detection and Measurement
----------------------------------


1. Clone the project 
> `git clone http://gitlab.sliit.lk/2020-065/2020-065.git`

2. Open Unity Hub 

3. Click on Add and select 2020-065/IT17160926/Measure

4. Install "XR Legacy Input Helpers" and  "Multiplayer HLAPI" from Unity Package Manager

5. Change to Android in Build Settings

6. Connect a ARCore supported Device and select it from the available devices
>  https://developers.google.com/ar/discover/supported-devices
7. Build and Run



Wall Paint Visualization and Suggest the Number of Paint Coats
----------------------------------

1. Clone the project
> `git clone http://gitlab.sliit.lk/2020-065/2020-065.git`

2. Download and install XAMPP v3.2.4
3. Set up XAMMP control panel as below
   
   In the control panel, a module 'Apache', go to 'config' button and select 'Apache(httpd-xampp.conf)' and change the code by replacing 'Require local' to 'Require all granted' as bellow.


        Alias /phpmyadmin "D:/xampp/phpMyAdmin/"
        <Directory "D:/xampp/phpMyAdmin">
        AllowOverride AuthConfig
        Require all granted
        ErrorDocument 403 /error/XAMPP_FORBIDDEN.html.var


4. Change the file path names in python script.

   There are two pythons scipts used. Those file names are 'paint' (inside the color coats folder) and 'color_detector' (color identify folder).
   In the 'paint' python script, it should give the file paths which is typed under the comment of  '#define file paths'
   In the 'color_detector' pyhton script, change the file paths according to the locations of the files.


5. Install android studio and open the android project.
6. Chech the device ip address using IP config command in command prompt and give the relevant ip address to inside android studio projects' activity named 'main2activity' (in given relevant location to type ip address )
7. Connect an android device and enable the developer option in the android device
8. Pair and select the relevant device from the android studio (or use an emulator)
9. Build and run


 Specify suitable furniture and decorations
----------------------------------

1. Clone the project
> `git clone http://gitlab.sliit.lk/2020-065/2020-065.git`
2. Download and install XAMPP v3.2.4
3. Set up XAMMP control panel as below
   
   In the control panel, a module 'Apache', go to 'config' button and select 'Apache(httpd-xampp.conf)' and change the code by replacing 'Require local' to 'Require all granted' as bellow.


        Alias /phpmyadmin "D:/xampp/phpMyAdmin/"
        <Directory "D:/xampp/phpMyAdmin">
        AllowOverride AuthConfig
        Require all granted
        ErrorDocument 403 /error/XAMPP_FORBIDDEN.html.var

4. Install android studio and open the android project.
5. Chech the device ip address using IP config command in command prompt and give the relevant ip address to inside android studio projects' activity named 'main2activity' (in given relevant location to type ip address )
6. Connect an android device and enable the developer option in the android device
7. Pair and select the relevant device from the android studio (or use an emulator)
8. Build and run


 
Position Recommendations
----------------------------------

1. Clone the project 
> `git clone http://gitlab.sliit.lk/2020-065/2020-065.git`
2. Open Unity Hub 

3. Click on Add and select 2020-065/IT17025904/furniture_placement

4. Install "XR Legacy Input Helpers" and  "Multiplayer HLAPI" from Unity Package Manager

5. Change to Android in Build Settings

6. Connect a ARCore supported Device and select it from the available devices
 >  https://developers.google.com/ar/discover/supported-devices
7. Build and Run


**Dependecies to execute the code**
----------------------------------

| Component     | Dependencies |  Version
| :------- | :--- | :---
| Object Detection and Measurement | Unity | 2019.4.10f1 or above | 
|  | Unity Hub |Latest|
|  | XR Legacy Input Helpers |2.1.4|
|  | Multiplayer HLAPI |1.0.6|
|  | Python |3.9|
|  | PyCharm IDE |3.9|
|    | OpenCv ||
|   | SQLite |3.2.1|
| Wall Paint Visualization and Suggest the Number of Paint Coats  | Android Studio  | 7.0 or above |
|  | Python  | 3.9 |
|  | XAMPP  | 3.2.4 |
|    | pandas ||
|    | pickle ||
|    | OpenCv ||
| Specify suitable furniture and decorations  | Android Studio  | 7.0 or above |
|  | Python  | 3.9 |
|  | XAMPP  |  |
|  | pandas  |  |
|   | SQLite |3.2.1|
| Position Recommendations | Unity | 2019.4.10f1 or above | 
|  | Unity Hub |Latest|
|  | XR Legacy Input Helpers |2.1.4|
|  | Multiplayer HLAPI |1.0.6|
|  | SQLite |3.2.1|



